#include <omp.h>
#include <stdio.h>
#include <stdlib.h>

struct Point {
  double x;
  double y;
  double z;
};

typedef struct Point Point;

#define NUM_POINTS 1000000
#define SEED 123456

int main(int argc, char ** argv)
{
  Point sum;
  Point * pointArray;
  int i = 0;

  //Allocate NUM_POINTS points
  pointArray = (Point *) malloc(NUM_POINTS*sizeof(Point));

  //Seed the random number generator
  srand(SEED);

  //Create randomly located points
  for(i = 0; i < NUM_POINTS; i++)
  {
    pointArray[i].x = i; //rand()/(double)RAND_MAX;
    pointArray[i].y = i; //rand()/(double)RAND_MAX;
    pointArray[i].z = i; //rand()/(double)RAND_MAX;
  }

  double sumx = sum.x = 0.0;
  double sumy = sum.y = 0.0;
  double sumz = sum.z = 0.0;

  #pragma omp parallel for private(i) reduction(+:sumx, sumy, sumz)
  for(i = 0; i < NUM_POINTS; i++)
  {
    sumx = sumx + pointArray[i].x;
    sumy = sumy + pointArray[i].y;
    sumz = sumz + pointArray[i].z;
  }

  sum.x = sumx;
  sum.y = sumy;
  sum.z = sumz;

  printf("The sum is %lf, %lf, %lf\n", sum.x, sum.y, sum.z);

  free((void *) pointArray);
  return 0;

}
