#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

char RockPaperScissorsLizardSpock(char, char);

int main(int argc, char ** argv)
{
  int i, j, k, l; //Loop counters
  int t; //The number of test cases
  int r; //The number of rows;
  int c; //The number of columns;
  int n; //The number of days;
  int in, out;
  char *** world;
  char aRow[101];
  world  = (char ***) malloc(sizeof(char **) * 2);
  scanf("%d", &t);
  
  for(i = 0; i < t; i++)
  {
    scanf("%d %d %d", &r, &c, &n);
    fgets(aRow, 100, stdin);
    in = 0;
    out = 1;
    //Allocate 2 2D arrays
    world[in] = (char **) malloc(sizeof(char *)*r);
    world[out] = (char **) malloc(sizeof(char *)*r);
    for(j = 0; j < r; j++)
    {
      world[in][j] = (char *) malloc(sizeof(char)*c);
      world[out][j] = (char *) malloc(sizeof(char)*c);
    }
    
    //fill the input array with data
    for(k = 0; k < r; k++)
    {
      fgets(aRow, 100, stdin);    
      for(l = 0; l < c; l++)
        world[out][k][l] = aRow[l];
    }

    //Begin processing for each time step
    for(j = 0; j < n; j++)
    {
      out = 1 - out;
      in  = 1 - out;
      for(k = 0; k < r; k++)
      {
        for(l = 0; l < c; l++)
        {
          char winner[4];
          winner[0] = winner[1] = winner[2] = winner[3] = world[in][k][l];

          //Round 1
          if(k-1 >= 0 && k-1 < r)
             winner[0] = RockPaperScissorsLizardSpock(world[in][k][l], world[in][k-1][l]);
          if(k+1 >= 0 && k+1 < r)
             winner[1] = RockPaperScissorsLizardSpock(world[in][k][l], world[in][k+1][l]);
          if(l-1 >= 0 && l-1 < r)
             winner[2] = RockPaperScissorsLizardSpock(world[in][k][l], world[in][k][l-1]);
          if(l-1 >= 0 && l-1 < r)
             winner[3] = RockPaperScissorsLizardSpock(world[in][k][l], world[in][k][l+1]);

          //Round 2
          winner[0] = RockPaperScissorsLizardSpock(winner[0], winner[1]);
          winner[1] = RockPaperScissorsLizardSpock(winner[2], winner[3]);

          //Round 3
          world[out][k][l] = RockPaperScissorsLizardSpock(winner[0], winner[1]);
        }
      }
    }

    for(k = 0; k < r; k++)
    {
      for(l = 0; l < c; l++)
        printf("%c", world[out][k][l]);
      printf("\n");
    }

  }


  free((void *) world);
  return 0;
}

char RockPaperScissorsLizardSpock(char a, char b)
{
  //Tie
  if(a == b)
    return a;
  //Paper covers rock
  else if(a == 'P' && b == 'R' || a == 'R' && b == 'P')
    return 'P';
  //Rock crushes lizard
  else if(a == 'L' && b == 'R' || a == 'R' && b == 'L')
    return 'R';
  //Lizard poisons Spock
  else if(a == 'L' && b == 'K' || a == 'K' && b == 'L')
    return 'L';
  //Spock smashes Scissors
  else if(a == 'K' && b == 'S' || a == 'S' && b == 'K')
    return 'K';
  //Scissors cut paper
  else if(a == 'S' && b == 'P' || a == 'P' && b == 'S')
    return 'S';
  //Scissors decapitates Lizard
  else if(a == 'S' && b == 'L' || a == 'L' && b == 'S')
    return 'S';
  //Rock crushes Scissors
  else if(a == 'R' && b == 'S' || a == 'S' && b == 'R')
    return 'R';
  //Lizard eats Paper
  else if(a == 'P' && b == 'L' || a == 'L' && b == 'P')
    return 'L';
  //Paper disproves Spock
  else if(a == 'P' && b == 'K' || a == 'K' && b == 'P')
    return 'P';
  //Spock vaporizes Rock
  else if(a == 'K' && b == 'R' || a == 'R' && b == 'K')
    return 'K';  
}
