#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#define N 1000000

int main(int argc, char ** argv)
{
  double * dArr;
  dArr = (double *) malloc(sizeof(double)*N);
  int tid, i;
  double sum0 = 0, sum1 = 0;

  for(i = 0; i < N; i++)
    dArr[i] = i;

  #pragma omp parallel private(tid, i) shared(dArr, sum0, sum1) num_threads(2)
  {
    tid = omp_get_thread_num();
    if(tid == 0)
      for(i = 0; i < N/2; i++)
        sum0 += dArr[i];
    else if(tid == 1)
      for(i = N/2; i < N; i++)
        sum1 += dArr[i];
  }

  printf("The sum of the elements in the array is %lf\n", (sum0+sum1));

  free((void *) dArr);
  return 0;
}
